/*  Copyrigth 2003 Laurent Van Begin and Gilles Geeraerts
 *
 *  This file is part of the CBP2GM compiler.
 *
 *  The CBP2GM compiler is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The CBP2GM compiler is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with CBP2GM; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
%{
#include "CBP.h"
#include "y.tab.h"
#include "string.h"
#define YY_NO_UNPUT
%}

CARAC		[a-zA-Z]
CHIFFRE		[0-9]
NUM		[0-9]+
ID		[a-zA-Z][a-zA-Z0-9]*

%%
\/\/.*		{}
[ \t]		{}
\n		{extern int lineno ; ++lineno ;}
{NUM}		{	yylval.name=(char *)malloc(yyleng*sizeof(char)) ;
			strcpy(yylval.name, yytext) ;
			return number ;
		}
vars		{return VARS ;}
locks		{return LOCKS ; }
messages	{return MESSAGES ;}
threads		{return THREADS ;}
if		{return IF ;}
elseif		{return ELSEIF ;}
else		{return ELSE ;}
while		{return WHILE ;}
skip		{return SKIP ;}
goto		{return GOTO ;}
lock		{return LOCK ;}
unlock		{return UNLOCK ;}
sleep		{return SLEEP ;}
wakeup		{return WAKEUP ;}
wakeupall	{return WAKEUPALL ;}
start		{return START ;}
rendezvous	{return RDV ;}
accept		{return ACCEPT ;}
true		{return TRUE ;}
false		{return FALSE ;}
choice		{return CHOICE ;}
":="		{return EQUAL ;}
{ID}		{ 	yylval.name=(char *)malloc((yyleng+1)*sizeof(char)) ;
			strcpy(yylval.name, yytext) ;
			return ident ;
		}
.		{return yytext[0] ;}

%%

/*int main (void)
{
	while(1)
	{
		printf("%d\n",yylex()) ;
	}
}*/
