/*  Copyrigth 2003 Laurent Van Begin and Gilles Geeraerts
 *
 *  This file is part of the CBP2GM compiler.
 *
 *  The CBP2GM compiler is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The CBP2GM compiler is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include"localvaluation.h"


//transform an expression into a vector used to make some transformation 
int *transform_expression(ExpressionRet *exp, int nb_value) {
        int * sol = (int *) malloc (nb_value * sizeof(int));
	int i;

	for (i = 0;i < nb_value;i++) {
		if (i != exp->var)
                        sol[i] = _NO_VALUE;
		else {
			if (exp->not == 0)
				sol[i] = _TRUE_VALUE;
			else
				sol[i] = _FALSE_VALUE;
		}
	}
	return sol;
}

//transform a list of expression into a vector unsed to make some transformation 
int *transform_expression_list(ExpListRet *list_exp, int nb_value) {
        int * sol = (int *) malloc (nb_value * sizeof(int));
        int i;
        ExpListRet *ptr;

        for (i = 0;i < nb_value;i++)
                sol[i] = _NO_VALUE;
        ptr = list_exp;
        while (ptr != NULL) {
                if (ptr->exp->not == 0)
                        sol[ptr->exp->var] = _TRUE_VALUE;
                else
                        sol[ptr->exp->var] = _FALSE_VALUE;
        }
        return sol;
}

/*return 0 if different
return 1 if the same*/
int test_value(int *value1, int *value2,int nb_val) {
	int i;
	int sol = 1;
	
	for (i=0;(i < nb_val) && (sol == 1);i++) {
		if ((value2[i] != _NO_VALUE) && (value1[i] != value2[i]))
			sol = 0;
	}
	return sol;
}

void apply_transformation(int *value, int *modif, int nb_value) {
        int i;

        for (i = 0; i < nb_value;i++){
                if (modif[i] != _NO_MODIF_VALUE)
                        value[i] = modif[i];
        }
}
