/*  Copyrigth 2003 Laurent Van Begin and Gilles Geeraerts
 *
 *  This file is part of the CBP2GM compiler.
 *
 *  The CBP2GM compiler is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The CBP2GM compiler is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with CBP2GM; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "stringmanip.h"

/* This function concatenates the guard with the condtion specified through var (a string
   containing a variable name) and not (equal to 1 if the variable is negated, equal to 0 otherwise). 
   It adds the necessary delimiter. guard must be of sufficient length */
void add_to_guard(char * guard, char * name, int not) 
{
	char * buf  ;
	if (not == 1)
	{
		buf =(char*)malloc(strlen(name)+strlen(_NOTBEGIN_) + strlen(_NOTEND_)+1) ;
		sprintf(buf, "%s%s%s", _NOTBEGIN_, name, _NOTEND_) ;
	}
	else
	{
		buf =(char*)malloc(strlen(name)+1) ;
		strcpy(buf, name) ;
	}

	if (strlen(guard) != 0)
		strcat(guard, _DELIM_) ;
	strcat(guard, " ") ;
	strcat(guard, buf) ;
}

/* This function concatenates the action with the assignation specified through
   name (a string containing the var. name) and val (see defines in stringmanip.h), adding the necessary
   delimiter. action must be of sufficient length */
void add_to_action(char * action, char * name, char * val) 
{
	if (strlen(action) != 0)
		strcat(action, _DELIM_) ;
	strcat(action, name) ;
	strcat(action, _ASSIGN_) ;
	strcat(action, val) ;

}

/* This function returns a new string that is concatenation of
   the guard an the action, with the necessary delimiter */
char * concat_guard_action(char * guard, char * action) 
{
	char * buf =(char *)malloc(sizeof(char)*(strlen(guard)+strlen(action)+strlen(_DELIM_)+2)) ;
	buf[0] = 0 ;
	if (strlen(action) != 0)
	{
		strcat(buf, action) ;
		strcat(buf, _DELIM_) ;
		strcat(buf, " ") ;
	}
	strcat(buf, guard) ;
	return buf ;
}
